 
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;
;
; Copyright (C) 2003 Xavier Fenard tout droits rservs. Autorisation
; est donne pour utiliser, modifier ou distribuer ce logiciel tant qu'il
; n'est pas vendu ou exploit pcuniairement.
; CE LOGICIEL EST DONNE TEL QUEL ET SANS AUCUNE GARANTIE, NI EXPLICITE OU IMPLICITE
;
;
; Copyright (C) 2003 Xavier Fenard All rights reserved. Permission
; is granted to use, modify, or redistribute this software so long as it is
; not sold or exploited for profit.
; THIS SOFTWARE IS PROVIDED AS IS AND WITHOUT WARRANTY OF ANY KIND, EITHER
; EXPRESSED OR IMPLIED.
;
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;JOURNAL
;Allumage electronique
;
;vitesse ralenti 	2000 2500 tours minutes
;vitesse max 	   12000 tours minutes

;calcul de l'avance
;	2000 T/m 	F:33Hz	30ms
;	12000 T/m	F:200Hz 5ms

;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;Consommation du prototype (12V)
;25HZ	40ms		1500T/mm		82mA
;50HZ	20ms		3000T/mm		128mA
;100HZ	10ms		6000T/mm		195mA

;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;
 processor 16F84   
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;
;FXHARD
 


;RA0		nc
;RA1		out pulse thyristor
;RA2		nc
;RA3		in detection rupteur 
;RA4		nc

;PB7		in HT trop haute si zero
;PB6		in SW3
;PB5		in SW2
;PB4		in SW1
;PB3		out pont oscillateur HT
;RB2		CONTACT allumage
;RB1		nc
;RB0		out pont oscillateur HT

;OSC		in THT + test gachette
;OSC		in THT + sensor ON
;CLR		contact/ 0: all off

;commande
#define oscHT1 PORTB,3
#define oscHT2 PORTB,0
#define THYCMD PORTA,1
;in status..
#define HTHIGH	PORTB,7
#define SW3	PORTB,6
#define SW1	PORTB,5
#define SW2	PORTB,4
#define CONTACT	PORTB,2
#define Rupteur PORTA,3

;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;file registers        ;bank
INDF:   EQU 00h        ;0 & 1
TMR:    EQU 01h        ;0
OPTIO:  EQU 01h        ;1
PCL:    EQU 02h        ;0 & 1
STATUS: EQU 03h        ;0 & 1
FSR:    EQU 04h        ;0 & 1
PORTA:  EQU 05h        ;0
TRISA:  EQU 05h        ;1
PORTB:  EQU 06h        ;0
TRISB:  EQU 06h        ;1
EEDATA: EQU 08h        ;0
EECON1: EQU 08h        ;1
EEADR:  EQU 09h        ;0
EECON2: EQU 09h        ;1
PCLATH: EQU 0Ah        ;0 & 1
INTCON: EQU 0Bh        ;0 & 1

W:      EQU 0  ;Result to go into working register (accumulator)
F:      EQU 1  ;Result to go into a file register.

;STATUS FLAGS

C:      EQU 0  ;Carry flag  (located in STATUS register)
CY: EQU 0  ;  "
DC:     EQU 1  ;Digit carry            "
Z:      EQU 2  ;Zero flag              "
PD:     EQU 3  ;Power Down bit         "
TO:     EQU 4  ;Time-out bit           "

;INTCON FLAGS
TOIF:   EQU 2  ;tmr0 int INTCON reg  
INTF:   EQU 1  ;Int interrupt flag
GIE:    EQU 7  ;GIE bit in INTCON reg




;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;Macro
push    MACRO
    movwf   SAVEW           ;save W
    swapf   STATUS,w        ;move status without altering flags
    movwf   SAVEPSW         ;save STATUS
    ENDM

pop     MACRO
    swapf   SAVEPSW,w
    movwf   STATUS          ;restore STATUS without altering flags 
    swapf   SAVEW
    swapf   SAVEW,w         ;restore W without altering flags
    ENDM

ei      MACRO
    bsf     INTCON,7        ;enable interrupts
    ENDM
    
di      MACRO
    bcf     INTCON,7        ;disable interrupts
    ENDM

#DEFINE BANK0   bcf STATUS,5
#DEFINE BANK1   bsf STATUS,5



;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;option regsiter
   
_CP_ON                       EQU     H'3FEF'
_CP_OFF                      EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FFF'
_PWRTE_OFF                   EQU     H'3FF7'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LP_OSC                      EQU     H'3FFC'
_XT_OSC                      EQU     H'3FFD'
_HS_OSC                      EQU     H'3FFE'
_RC_OSC                      EQU     H'3FFF'

    


;     __CONFIG 0F2h   ;MPASM config
;    __CONFIG _HS_OSC&_Chien&PROT&_PWRTE_OFF
 
;configuration osc RC 4K7/22pF osc2=osc1/4=1Mhz, donc 4MHZ 
    __CONFIG _RC_OSC&_WDT_OFF&_CP_OFF&_PWRTE_OFF


;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;ram 
SAVEW:      EQU 0Ch         ;push and pop
SAVEPSW:    EQU 0Dh         ;push and pop

FLAGS       EQU 0Eh         ;
COUNTL:     EQU 0Fh         ;
COUNTH:     EQU 10h         ;
AUTO0:      EQU 11h         ;
AUTO1:      EQU 12h         ;
R0:         EQU 13h         ;
R1:         EQU 14h         ; 
R2:         EQU 15h         ;
BYTE0       EQU 16h         ;
BYTE1:      EQU 17h         ;
BYTE2:      EQU 18h         ;
BYTE3:      EQU 19h         ;
BYTE4:      EQU 1Ah         ;
BYTE5:      EQU 1Bh         ;
BYTE6:      EQU 1Ch         ;
BYTE7:      EQU 1Dh         ;
BYTE8:      EQU 1Eh         ;
CHAN:       EQU 1Fh         ;
BYTE0H:     EQU 20h         ;
MODE:       EQU 21h         ;
LSB:        EQU 22h         ;
MSB:        EQU 23h         ;
FREQL:      EQU 24h         ;
FREQH:      EQU 25h         ;
;:          EQU 26h             ;


;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;

RESET       org 0x0000          ; RAZ

        movlw 0x00              ;port off
        movwf PORTA
	   movwf PORTB
        
    
    		BANK1			 ;FXHARD
    		movlw 0xFD         	 ;port (1=in)
    		movwf PORTA  
		movlw 0xF6           ;port (1=in)
    		movwf PORTB

		movlw 0x07		;/4 /256 =/1024
		movwf OPTIO		;timer interne, 4Mhz donne 3,9khz TMR b0
    		BANK0
    

       
        
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;
AlmeOff:	call PhaseOff
Almeloop: 
		
		btfss CONTACT		;contact allumage: arret si 
		goto AlmeOff		;a la masse
		
		btfss SW1			; THT seul
;		call PhaseTHT		;non asservi
		call PhaseTHTA
		btfss SW1
		goto Almeloop		 
		
#define PERGACHTST TMR,6

		btfsc SW2			;mode test gachette
		goto Almel2		;genere un eclair
		call PhaseTHTA		
		btfsc  PERGACHTST	;periode
		goto Almeloop
Almel1:	call PhaseTHTA	
		btfss  PERGACHTST 
		goto Almel1
		call Thryst	
		goto Almeloop


Almel2:	btfsc SW3			;mode run
		goto AlmeOff		; aucun jumper, THT off...
		call PhaseTHTA		;HT  asservie
		incf COUNTL,f		;mesure vitesse
		skpnz
		incf COUNTH,f	

	#if 1
;version: signal  bobine:______|-----|_____
;				gachette:____________|_____
;fonctionne. sans gestion d'avance
		btfsc Rupteur		;detection rupteur fin pulse 1		
		goto Almeloop
		;call Avance
;		movlw 0x40			;20uS*64=1280
;		movwf R0
;		call PhaseDel		;retard
		call Thryst			;etincelle
		clrf COUNTL
		clrf COUNTL			;raz mesure vitess
Almel20:  btfss CONTACT		;contact allumage
		goto AlmeOff
		call PhaseTHTA		;HT  asservie	
		btfss Rupteur		;attente pulse a 1
		goto Almel20
		goto Almeloop
	
	
	#else	
;version: signal  bobine:______|-----|_____
;				gachette:______|___________
;ne fonctionne pas...retour de manivelle.
	
		btfss PORTB,7		;detection rupteur pulse 1		
		goto Almeloop
		call Avance
		call Thryst			;etincelle
		clrf COUNTL
		clrf COUNTL			;raz mesure vitess
Almel20:btfss PORTA,3		;contact allumage
		goto AlmeOff
		call PhaseTHTA		;HT  asservie	
		btfsc PORTB,7		;fin rupteur,retour 0
		goto Almel20
		goto Almeloop
	#endif

		
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;

		
;calcul de l'avance
;boucle run environ 25microsec
; 30ms ralenti				compteur 1000
;  5ms vitess max			compteur 200 

Avance: movf COUNTH,f		;test ralenti
		skpnz
		return				;pas d'avance en max
		movlw 0C0h			;
		movwf R0			;timeout
Almel21:btfsc PORTB,3		;ht trop haute?
		call PhaseTHT
		btfss PORTB,3		;ht trop haute?
		call PhaseOff		;arret tht
		decfsz R0,f
		goto Almel21		;environ 13us
		return
		
		
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;Pulse thrysistor
Thryst
	bcf oscHT1
	bcf oscHT2		;arret generateur		
	nop
	bsf THYCMD		;fire
	nop
	nop
	nop
	nop
	nop
	bcf THYCMD		;stop fire
	return	

;seconde impulsion (mettre return en commenctaire)
	
	nop
	nop
	nop
	nop
	bsf THYCMD		;fire
	nop
	nop
	nop
	nop
	nop
	bcf THYCMD		;stop fire
	nop
	nop
	nop				;remise en phase...
	return	
	
	
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;PhaseTHT
PhaseDel call PhaseTHTA		;2+10
	decfsz R0,f			;2
	goto PhaseDel
	return				;4=20uS environ	

PhaseTHTA
	btfss HTHIGH		;ht trop haute?	
	goto PhaseOff		;oui

PhaseTHT
;	btfsc TMR,1			;copie le b1 du tmr (2khz)
	btfsc TMR,0			;copie le b0   du tmr (4khz)
	goto PhaseTHT1 
	bcf oscHT1			;FXHARD
	bsf oscHT2
	return
PhaseTHT1
	bsf oscHT1
	bcf oscHT2
	return

PhaseOff
	bcf oscHT1
	bcf oscHT2
	return




;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;


DelaiL1s:movlw 8       ;
DelaiLL: call Delai2
        addlw 0xFF          ;dec
        skpz
        goto DelaiLL
        return


Delai2: clrf R1			;delai max 256ms
Delai1: clrf R0         ;delai max 4*256us=1024us
Delai1L:nop				;1
		incfsz R0,f	;1..2 
		goto Delai1L 	;2 loop 4
        incfsz R1,f
        goto Delai1 
        return
        

;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;
        


                end
